<?php

/**
 * @file
 * Post update functions for the AWS module.
 */

use Drupal\aws\Entity\ProfileInterface;

/**
 * Migrate credentials to the new config schema.
 */
function aws_post_update_migrate_credentials() {
  $storage = \Drupal::entityTypeManager()->getStorage('aws_profile');
  /** @var \Drupal\aws\Entity\ProfileInterface[] $profiles */
  $profiles = $storage->loadMultiple();

  foreach ($profiles as $profile) {
    if (!$profile->getProvider()) {
      $provider_config = [
        'key_id' => $profile->get('aws_access_key_id'),
        'secret' => $profile->get('aws_secret_access_key'),
      ];

      $profile
        ->setProvider(ProfileInterface::PROVIDER_KEYS)
        ->setProviderConfig($provider_config)
        ->save();
    }
  }
}
